package com.cf.imes.framework.organ.core.security;

import cn.hutool.core.collection.CollUtil;
import com.cf.imes.framework.common.exception.enums.GlobalErrorCodeConstants;
import com.cf.imes.framework.common.pojo.CommonResult;
import com.cf.imes.framework.common.util.servlet.ServletUtils;
import com.cf.imes.framework.security.core.LoginUser;
import com.cf.imes.framework.security.core.util.SecurityFrameworkUtils;
import com.cf.imes.framework.organ.config.OrganProperties;
import com.cf.imes.framework.organ.core.context.OrganContextHolder;
import com.cf.imes.framework.organ.core.service.OrganFrameworkService;
import com.cf.imes.framework.web.config.WebProperties;
import com.cf.imes.framework.web.core.filter.ApiRequestFilter;
import com.cf.imes.framework.web.core.handler.GlobalExceptionHandler;
import com.cf.imes.framework.web.core.util.WebFrameworkUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.AntPathMatcher;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Objects;

/**
 * 多组织 Security Web 过滤器
 * 1. 如果是登陆的用户，校验是否有权限访问该组织，避免越权问题。
 * 2. 如果请求未带组织的编号，检查是否是忽略的 URL，否则也不允许访问。
 * 3. 校验组织是合法，例如说被禁用、到期
 *
 * 校验用户访问的组织，是否是其所在的组织，
 *
 * @author 晨丰科技
 */
@Slf4j
public class OrganSecurityWebFilter extends ApiRequestFilter {

    private final OrganProperties organProperties;

    private final AntPathMatcher pathMatcher;

    private final GlobalExceptionHandler globalExceptionHandler;
    private final OrganFrameworkService organFrameworkService;

    public OrganSecurityWebFilter(OrganProperties organProperties,
                                  WebProperties webProperties,
                                  GlobalExceptionHandler globalExceptionHandler,
                                  OrganFrameworkService organFrameworkService) {
        super(webProperties);
        this.organProperties = organProperties;
        this.pathMatcher = new AntPathMatcher();
        this.globalExceptionHandler = globalExceptionHandler;
        this.organFrameworkService = organFrameworkService;
    }

    @Override
    protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain chain)
            throws ServletException, IOException {
        Long organId = WebFrameworkUtils.getOrganId(request);
        // 1. 登陆的用户，校验是否有权限访问该组织，避免越权问题。
        LoginUser user = SecurityFrameworkUtils.getLoginUser();
        if (user != null) {
            // 如果获取不到组织编号，则尝试使用登陆用户的组织编号
            if (organId == null) {
                organId = user.getOrganId();
                OrganContextHolder.setOrganId(organId);
            // 如果传递了组织编号，则进行比对组织编号，避免越权问题
            } else if (!Objects.equals(user.getOrganId(), OrganContextHolder.getOrganId())) { // Cloud 特殊逻辑：如果是 RPC 请求，就不校验了。主要考虑，一些场景下，会调用 OrganUtils 去切换组织
                log.error("[doFilterInternal][组织({}) User({}/{}) 越权访问组织({}) URL({}/{})]",
                        user.getOrganId(), user.getId(), user.getUserType(),
                        OrganContextHolder.getOrganId(), request.getRequestURI(), request.getMethod());
                ServletUtils.writeJSON(response, CommonResult.error(GlobalErrorCodeConstants.FORBIDDEN.getCode(),
                        "您无权访问该组织的数据"));
                return;
            }
        }

        // 如果非允许忽略组织的 URL，则校验组织是否合法
        if (!isIgnoreUrl(request)) {
            // 2. 如果请求未带组织的编号，不允许访问。
            if (organId == null) {
                log.error("[doFilterInternal][URL({}/{}) 未传递组织编号]", request.getRequestURI(), request.getMethod());
                ServletUtils.writeJSON(response, CommonResult.error(GlobalErrorCodeConstants.BAD_REQUEST.getCode(),
                        "请求的组织标识未传递，请进行排查"));
                return;
            }
            // 3. 校验组织是合法，例如说被禁用、到期
            try {
                organFrameworkService.validOrgan(organId);
            } catch (Throwable ex) {
                CommonResult<?> result = globalExceptionHandler.allExceptionHandler(request, ex);
                ServletUtils.writeJSON(response, result);
                return;
            }
        } else { // 如果是允许忽略组织的 URL，若未传递组织编号，则默认忽略组织编号，避免报错
            if (organId == null) {
                OrganContextHolder.setIgnore(true);
            }
        }

        // 继续过滤
        chain.doFilter(request, response);
    }

    private boolean isIgnoreUrl(HttpServletRequest request) {
        // 快速匹配，保证性能
        if (CollUtil.contains(organProperties.getIgnoreUrls(), request.getRequestURI())) {
            return true;
        }
        // 逐个 Ant 路径匹配
        for (String url : organProperties.getIgnoreUrls()) {
            if (pathMatcher.match(url, request.getRequestURI())) {
                return true;
            }
        }
        return false;
    }

}
